#include "ti86asm.inc"

.org _asm_exec_ram

	call _clrLCD
	call static
	call _clrLCD
	ld hl,(256*15)+10
	ld c,l
	ld (_penCol),hl
	ld hl,string
	call string_display
	call _getkey
	jp _clrLCD

static:
	ld b,200
static_loop:
		push bc
	ld bc,$400		;size of video memory
	ld a,r			;semi random number
	ld h,a
	ld l,a
	ld de,$fc00		;video memory
	ldir
		pop bc
	djnz static_loop
	ret

string_display:
	ld a,(_penCol)		;where text started displaying
	ld c,a			;save in c for use when new line
string_display_loop:
	ld a,(hl)		;get letter from string
	inc hl			;set up for next letter
	or a			;is it zero?
	ret z			;done if it was zero
	cp 1			;is it a new line character?
	call  z,new_line	;go to next line
	call _vputmap
string_wait:
	ld b,0
string_wait_loop:
		push bc
	ld b,200
string_wait_loop_2:
	djnz string_wait_loop_2
		pop bc
	djnz string_wait_loop
	jr string_display_loop
new_line:
		push af
		push hl
	ld hl,_penRow		;work with address of row
	ld a,6			;7 pixels down
	add a,(hl)		;add to current columns
	ld (hl),a		;put it in columns
	ld a,c
	ld (_penCol),a		;c is preset to be the column
				; text is supposed to wrap to
		pop hl
		pop af
	ld a,(hl)
	inc hl			;next character
	ret

string:	.db "aliens have invaded your",1,"planet.  you must escape to",1,"the planet"
	.db "of gauk.",0
.end
